/*
    3 _̃f[^ Vto, Rd+Rs, Kp Q߂

    LTspice  Tools Control Panel Operation  .net, .log t@C
    Ȃ悤ɐݒ肵ĂƁB

    MSYS+MinGW ł mmap() gȂ͗l
    void * mmap (void *address, size_t length,int protect, int flags,
     int filedes, off_t offset);
*/

#include <stdio.h>
#include <ctype.h>
#include <math.h>
#include <string.h>
#include <stdlib.h>
/* #include <windows.h> */

const char* name  = "R2026";
const char mname[64];  /* model filename */
const char fname[64];  /* log filename */

/* l */
double Vto = 1.7;
double Rd = 5.1e-3;
double Rs = 3.9e-3;
double Kp = 300;

#define N  4
#define M  3
#define P  3
double d[N][M][P];  /* .log t@Cǂݏof[^ */

/*
    .mod t@CXV (O[oϐƓƂɒӁB͕ʕB)
    WvZKvAp[^[̗L傫Ă
*/
int w_mod(double Vto, double Rd, double Rs, double Kp)
{
    FILE* ofp;
    if ((ofp = fopen(mname, "w")) == NULL)
        return -1;
    fprintf(ofp, ".model %s VDMOS(Rg=3 Vto=%.8f Rd=%.8fm Rs=%.8fm\n",
     name, Vto, 1e3*Rd, 1e3*Rs);
    fprintf(ofp, "+ Rb=15m Kp=%.6f Cgdmax=1.2n Cgdmin=0.30n Cgs=2.0n\n", Kp);
    fprintf(ofp, "+ Cjo=0.60n Is=60p Vds=20 Ron=14m Qg=20n)\n");
    if (fclose(ofp))
        return -1;
    return 0;
}

/*
    .log t@Cǂ݁Adouble A[ d Ɋi[
*/
int p2(FILE* ifp)
{
    char buf[32768];
    char *p, *s;
    int st0 = -1, st1 = 0;

/*    printf("\n"); */
    while (fgets((p = (char*)&buf), sizeof(buf), ifp) == (char*)&buf) {
        if (strstr(p, (const char*)"WARNING:")) {
            printf("# %s", p);
            continue;
        }
        /* printf("%s", p); */
        if (strstr(p, "Measurement:")) {
            st0 += 1, st1 = 0;
            continue;
        }
        if (st0 >= 0) {
            if (strstr(p, "step")) {
                ;
            } else {
                s = p;
                while (*s == ' ')
                    s += 1;
                if (isdigit(*s) || *s == '.') {
                    if (st0 < N && st1 < M) {
                        if (sscanf(s, "%lf %lf %lf",
                         &d[st0][st1][0], &d[st0][st1][1], &d[st0][st1][2]) != M) {
                            printf("# Error [%d,%d] %s", st0, st1, s);
                            return -1;
                        }
                    } else {
                        printf("# Error [%d,%d] %s", st0, st1, s);
                        return -1;
                    }
                    st1 += 1;
                    continue;
                } else if (*s < ' ')
                    continue;
            }
        }
    }
    int i, j;
    /* trim d[i][j][0] (first column) */
    const double idval[N - 1] = { 2, 5, 10 };
    for (i = 0; i < N; i += 1)
        for (j = 0; j < M; j += 1)
            d[i][j][0] = idval[j];

    /* trim d[3][][1] */
    for (j = 0; j < M; j += 1)
        d[3][j][1] = 0.2;

    /* exchange d[][][1,2] */
    for (i = 0; i < N; i += 1)
        for (j = 0; j < M; j += 1) {
            double temp;
            temp = d[i][j][1];
            d[i][j][1] = d[i][j][2];
            d[i][j][2] = temp;
    }
#if 0
    printf("      Id    Vg    Vd\n");
    for (i = 0; i < N; i += 1)
        for (j = 0; j < M; j += 1)
            printf("[%d,%d] %10g %10g %10g\n", i, j,
             d[i][j][0], d[i][j][1], d[i][j][2]);
#endif
    return 0;
}

/*
    .mod t@CXVAscad3 sAVf[^擾
*/
int p1(double Vto, double Rd, double Rs, double Kp)
{
    if (w_mod(Vto, Rd, Rs, Kp)) {
        printf("w_mod(%s) fail", mname);
        return -1;
    }
    if (system("..\\..\\SwCADIII\\scad3.exe -b R2026.net")
     || system("..\\..\\ltsputil\\WaitSec.exe 0.3")) {
        printf("scad3 or WaitSec execution fail\n");
        return -1;
    }
    FILE* ifp;
    if ((ifp = fopen(fname, "r")) == NULL) {
        printf("fopen(%s) fail\n", fname);
        return -1;
    }
    int r = p2(ifp);
    fclose(ifp);
    if (r)
        return -1;
    return 0;
}

/*
    f[^V[gǂݎl̑O
*/
double a[][3] = {
    {  0, 367, 680 },  /* _ */
    {  2, 484, 577 },  /* Vg=2, Id=2 */
    {  5, 543, 499 },  /* Vg=3, Id=5 */
    { 10, 602, 359 },  /* Vg=4, Id=10 */
    { 10, 895, 417 },  /* Vg=9, Id=10, Vg  */
    { 10, 484,  94 }   /* Vg2, Vd=0.2, Vd  */
};

void p_dsd()
{
    int i, m;
    double ux, uy;
    m = sizeof(a) / sizeof(a[0]);
    for (i = 1; i < m; i += 1) {
        a[i][1] -= a[0][1];
        a[i][2] = a[0][2] - a[i][2];
    }
    ux = a[4][1] / 9.0;
    uy = a[5][2] / 0.2;
    for (i = 1; i < m; i += 1) {
        a[i][1] /= ux;
        a[i][2] /= uy;
    }
    a[1][1] = 2;  /*  2V */
    a[3][1] = 4;  /*  4V */
#if 0
    printf("      Id  Vg  Vd\n");
    for (i = 1; i < m; i += 1) {
        printf("[%d] %10g %10g %10g\n", i, a[i][0], a[i][1], a[i][2]);
    }
#endif
}

/* rׂf[^_ */
#if 0
#define A1  a[1][2]  /* Vd @ Id=2, Vg=2 */
#define A2  a[2][2]  /* Vd @ Id=5, Vg=3 */
#define A3  a[3][2]  /* Vd @ Id=10, Vg=4 */
#define D1  d[0][0][2]  /* Vd @ Id=2, Vg=2 */
#define D2  d[1][1][2]  /* Vd @ Id=5, Vg=3 */
#define D3  d[2][2][2]  /* Vd @ Id=10, Vg=4 */
#endif

/*
    r֐
*/
inline double b(int ix) { return a[ix + 1][2]; }  /* ix : 0..2 */
inline double c(int ix) { return d[ix][ix][2]; }

/*
    ŏ덷
*/
double mmse()
{
    double sum = 0;
    int i;
    for (i = 0; i < 3; i += 1)
        sum += pow(c(i)/b(i) - 1, 2);
    return sum;
}

/*
    p1()  mmse()
*/
double p1_mmse(double Vto, double Rd, double Kp)
{
    Rs = 3*Rd/4;  /* Rs = (3/4)*Rd */
    if (p1(Vto, Rd, Rs, Kp))
        exit(255);
    return mmse();
}

/*
    HwI format (@\)
*/
char* eng_fmt(char* s0, double a, int prec)
{
    const char e[] = "afpnum kMGTPE";
    char* s = s0;
    if (a < 0) {
        a = -a;
        *s++ = '-';
    }
    if (a < 1e-18 || a >= 1e21) {
        sprintf(s0, "%g", a);
        return s0;
    }
    double dx = log10(1e18 * a);
    int ix = (int)dx / 3 * 3 - 18;
    int ip = prec - ((int)dx % 3) - 1;
    if (ix)
        /* sprintf(s, "%.*fe%d", ip, a/pow(10, ix), ix); */
        sprintf(s, "%.*f%c", ip, a/pow(10, ix), e[(ix+18)/3]);
    else
        sprintf(s, "%.*f", ip, a);
    return s0;
}

/*
    3 _̃f[^g Vto, Rd+Rs, Kp Q߂
*/
#define NLOOP  50

int p0()
{
    p1(Vto, Rd, Rs, Kp);
    int i;
    for (i = 0; i < 3; i += 1)
        printf("%d %g %g\n", i, c(i), b(i));

    double u0, u1, u2, u3;
    double f = 1.001;
    double g = 1.0/6;
    for (i = 0; i < NLOOP; i += 1) {
        u0 = p1_mmse(Vto, Rd, Kp);
        u1 = p1_mmse(f*Vto, Rd, Kp)/u0;
        u2 = p1_mmse(Vto, f*Rd, Kp)/u0;
        u3 = p1_mmse(Vto, Rd, f*Kp)/u0;
        Vto = Vto / pow(u1, g);
        Rd  = Rd  / pow(u2, g);
        Kp  = Kp  / pow(u3, g);
        printf("%2d %g : %g %g %g\n", i, u0, Vto, Rd, Kp);
    }

    printf("Difference ratio:");
    for (i = 0; i < 3; i += 1)
        printf(" %g", c(i)/b(i));
    printf("\n");

    char s[4][32];
    printf("Vto=%s Rd=%s Rs=%s Kp=%s\n",
     eng_fmt(s[0], Vto, 4), eng_fmt(s[1], Rd, 4),
     eng_fmt(s[2], Rs, 4), eng_fmt(s[3], Kp, 4));
    return 0;
}

int main(int argc, char *argv[])
{
    snprintf((char*)mname, sizeof(mname), "%s.mod", name);
    snprintf((char*)fname, sizeof(fname), "%s.log", name);
    p_dsd();
    return p0() ? 255 : 0;
}
